; Resident SB mixer by Hory, 1999
; Feel free to modify or improve this code. But I would be happy if you
; told me what  (mail to hory@inf.bme.hu)
;
; Anyway, this code is ABSOLUTELY FREEWARE, ABSOLUTELY NO WARRANTY APPLIES!
;
; One more thing: I know it's not fully optimized, but I was lazy
; and anyway, in its current state it's much easier to add new functions.
;
; Compile with: TASM /m9 mixl.asm
;               TLINK /t /x mixl.obj
;
; Note: The only difference between MIX and MIXL is that MIXL is missing
; lines 233-255. That routine does that so-called tricky memory allocation.
; Lines 271-272 have been modified to go TSR the usual way.

Progi Segment para
assume cs:Progi,ds:Progi
org 100h

Start:
.486
locals
jumps
jmp Init

active db 0          ; =1 if activatorkey is held down
prevkey db 0         ; Last keycode received

setdefault EQU 35h
ActivatorKey EQU 37h ; Gray* key(37h) activates,
                     ; 35h (Gray/) sets default bass/treble/mic
                     ; Tip: if you don't use windows and have a win95
                     ;      keyboard, set the activator to 5dh (localmenu key)
                     ;      and setdefault to 5ch (Windows key, left to 5dh)
                     ;      Same applies to the MACRO key on some keyboards
;-------------------------------------------------------------------------------
int8p proc far

push ax              ; Check if a valid keycode is in keyboard puffer
in al,64h            ; It only works if int9 has been disabled
test al,0e1h         ;   (This usually happens under dos extenders)
jnz ennyi8
test al,10h
jz ennyi8
in al,60h
cmp al,cs:prevkey
jz ennyi8

call doit

ennyi8:
pop ax
db 234
int8 dd 0
endp
;-------------------------------------------------------------------------------
int9p proc far
assume cs:progi

push ax
in al,60h

call doit
or al,al
jnz ennyi

mov al,20h       ; INTACK
out 20h,al

in al,61h       ; Keyboard Acknowledge
or al,80h
out 61h,al
and al,7fh
out 61h,al
pop ax
iret

ennyi:
pop ax
db 234
int9 dd 0
endp
;-------------------------------------------------------------------------------
doit proc near

mov cs:prevkey,al
cmp al,ActivatorKey
jnz @@1
mov cs:active,1
ret

@@1:
cmp al,ActivatorKey+80h
jnz @@2
mov cs:active,0
ret

@@2:
cmp cs:active,1
jnz @@vege

push dx
cmp al,52h      ; Master
jnz @@3
mov ax,1122h
jmp setit

@@3:
cmp al,53h
jnz @@4
mov ax,0ef22h
jmp setit

@@4:            ; Wave
cmp al,47h
jnz @@5
mov ax,01104h
jmp setit

@@5:
cmp al,4fh
jnz @@6
mov ax,0ef04h
jmp setit

@@6:          ; MIDI
cmp al,49h
jnz @@7
mov ax,01126h
jmp setit

@@7:
cmp al,51h
jnz @@8
mov ax,0ef26h
jmp setit

@@8:
cmp al,4ah   ;CD
jnz @@9
mov ax,01128h
jmp setit

@@9:
cmp al,4eh
jnz @@10
mov ax,0ef28h
jmp setit

@@10:
cmp al,48h   ;Bass
jnz @@11
mov ax,01046h
jmp setit

@@11:
cmp al,50h
jnz @@12
mov ax,0f046h
jmp setit

@@12:
cmp al,4bh   ;Treble
jnz @@13
mov ax,01044h
jmp setit

@@13:
cmp al,4dh
jnz @@14
mov ax,0f044h
jmp setit

@@14:          ; set defaults -> gray/ button (by default)
cmp al,Setdefault
jnz ide
mov dx,224h
mov ax,063ch   ; don't mix other input signals for better quality
out dx,ax
mov ax,09044h  ; treble
out dx,ax
inc al
out dx,ax
inc al
out dx,ax
inc al
out dx,ax
jmp ide3

setit:
mov dx,224h
out dx,al
push ax
inc dx
in al,dx
add al,ah
cmp al,0
jz ide2
cmp al,0ffh
jz ide2
out dx,al

pop ax
cmp al,44h      ; Check if it's treble or bass
jl ide3         ; because both left & right channels must be set
inc al
dec dx
out dx,al
inc dx
in al,dx
add al,ah
out dx,al
jmp ide3

ide2:
pop ax
ide3:
xor al,al

ide:
pop dx
@@vege:
ret

endp
;-------------------------------------------------------------------------------
Init:
mov dx,offset text
mov ah,9
int 21h

;mov ah,4Ah
;mov bx,0ffffh
;int 21h
;sub bx,(offset init-offset start+15)/16+1
;mov ah,4ah
;int 21h

;mov ah,48h
;mov bx,(offset init-offset start+15)/16
;int 21h
                                 ; Modify MCB's owner to fool that stupid DOS.
;dec ax                          ; DOS would free that memory block on exit
;mov es,ax                       ; otherwise... :(
;inc ax
;mov word ptr es:[1],ax          ; set owner's PSP to interrupt handlers
;mov dword ptr es:[8],'IMBS'
;mov dword ptr es:[12],'X'       ; write 'SBMIX' as owner of MCB
;sub ax,10h
;mov di,100h
;mov es,ax                       ; ... and copy interrupt handlers there
;mov si,100h
;mov cx,(offset init-offset start+3)/4
;rep movsd

xor ax,ax
mov ds,ax
mov ebx,dword ptr ds:[4*9]
mov eax,dword ptr ds:[4*8]
mov es:int9,ebx
mov es:int8,eax
mov ax,es
shl eax,16
mov ax,offset int9p
mov dword ptr ds:[4*9],eax
mov ax,offset int8p
mov dword ptr ds:[4*8],eax

@@instvege:
;mov ax,4c00h
;int 21h
mov dx,offset init+1
int 27h

Text db 'Resident SB Mixer by Hory, 1999.03.18',10,13
     db 'EMail : Hory@inf.bme.hu      Web: http://www.inf.bme.hu/~hory/',10,13,'$'

Progi Ends
End Start